﻿#nullable enable

using System.Threading.Tasks;
using DevToys.Api.Tools;

namespace DevToys.Api.Core
{
    /// <summary>
    /// Provides a service allowing to activate the app throught a URI protocol.
    /// </summary>
    public interface IUriActivationProtocolService
    {
        /// <summary>
        /// Starts a new instance of the app with an argument.
        /// </summary>
        /// <returns>Returns <code>True</code> if it succeeded.</returns>
        Task<bool> LaunchNewAppInstance(string? arguments = null);

        /// <summary>
        /// Creates a tile on the Windows start menu that points to a given tool.
        /// </summary>
        /// <param name="toolProvider">The tool to pin</param>
        /// <returns>Returns <code>False</code> if the method internally failed.
        /// It will still return <code>True</code> if the user refuse to proceed when being prompt for pinning.</returns>
        Task<bool> PinToolToStart(ToolProviderViewItem toolProvider);
    }
}
